<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);
add_action("wp_ajax_ride_price","wprbp_ride_calculation");
add_action("wp_ajax_nopriv_ride_price","wprbp_ride_calculation");
function wprbp_ride_calculation(){
 	$distance = (float) str_replace(",","",$_POST['distance']);
	$rate = get_option("per_distance_rate");
	$traveldate = $_POST['traveldate'];
 	$currency = get_woocommerce_currency_symbol();
	$total_rate = $distance * $rate;
	$res_data = array("rate"=>$rate,"total_rate"=>round($total_rate,2), "currency" =>$currency,"traveldate" =>$traveldate);
	echo json_encode($res_data);
	exit();
}

add_action("wp_ajax_send_data_to_cart","wprbp_send_data_to_cart");
add_action("wp_ajax_nopriv_send_data_to_cart","wprbp_send_data_to_cart");

function wprbp_send_data_to_cart(){
	global $woocommerce;
	$woocommerce->cart->empty_cart();
	$source = $_POST['origin'];
	$destination = $_POST['destination'];
	$distance = $_POST['distance'];
	$traveldate = $_POST['travelschedule'];
	$total_rate = $_POST['total_price'];

	$product_id = get_option('ride_product_id');
	$woocommerce->cart->add_to_cart($product_id);
		
	$woocommerce->session->set( 'ride_booking_source', $source );
	$woocommerce->session->set( 'ride_booking_destination', $destination );
	$woocommerce->session->set( 'ride_booking_distance', $distance );
	$woocommerce->session->set( 'ride_booking_schedule', $traveldate);
	$woocommerce->session->set( 'ride_booking_price', $total_rate );

	$success['message'] = __('Product added to cart successfully', 'wp-ride-booking-pro');
	$success['cart_url'] = $woocommerce->cart->get_checkout_url();
	echo json_encode($success);
	die();
}
	
add_action('woocommerce_cart_calculate_fees','wprbp_add_fees');
function wprbp_add_fees(){
	global $woocommerce;
	$source = $woocommerce->session->get('ride_booking_source');
	$destination = $woocommerce->session->get('ride_booking_destination');
	$distance = $woocommerce->session->get('ride_booking_distance');
	$total_rate = $woocommerce->session->get('ride_booking_price');
	if ( is_admin() && ! defined( 'DOING_AJAX' ) )
		return;
	$product_id =  get_option('ride_product_id');
	$base_price = get_post_meta($product_id,'_price',true);

	$woocommerce->cart->add_fee( __( 'Base Price', 'wp-ride-booking-pro' ), $base_price, true, '' );
}

function wprbp_return_custom_price($price, $product) {
global $post,$wpdb,$woocommerce;
if(preg_match("#post_type=product#",$_SERVER["REQUEST_URI"])){
	    return $price;
}
$product_id =  get_option('ride_product_id');

if($product_id != $product->get_id()){
	return $price;
}else{
    $total_rate = $woocommerce->session->get('ride_booking_price');
	return $total_rate + $price;
}   
}
add_filter('woocommerce_product_get_price', 'wprbp_return_custom_price', 10, 2);

add_action('woocommerce_checkout_update_order_meta',function( $order_id, $posted ) {
 global $woocommerce;
  	$source = $woocommerce->session->get('ride_booking_source');
	$destination = $woocommerce->session->get('ride_booking_destination');
	$distance = $woocommerce->session->get('ride_booking_distance');
	$date = $woocommerce->session->get('ride_booking_schedule');
    $order = wc_get_order( $order_id );
    $order->update_meta_data( __( 'Travel From', 'wp-ride-booking-pro' ), $source );
    $order->update_meta_data( __( 'Travel To', 'wp-ride-booking-pro' ), $destination );
    $order->update_meta_data( __( 'Travel Date', 'wp-ride-booking-pro' ), $date);
    $order->update_meta_data( __( 'Travel Total Distance', 'wp-ride-booking-pro' ), $distance );		
    $order->save();
} , 10, 2);
?>